# This is the real version, we call it 2.9.0p1 to avoid rpm versioning
# problems when 2.9.1p1 comes out.
%define oversion 3.1p1
#ugly hack
%define _noVersionedDependencies 1

Summary: OpenSSH free Secure Shell (SSH) implementation
Name: openssh
Version: 3.1.0p1
Release: 7tr
License: BSD
Group: Network/Utilities
Source0: ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-%{oversion}.tar.gz
Source1: sshd_config
Patch1: openssh-3.1p1-adv.token.patch
Patch2: openssh-3.1p1-auth2.patch
Patch3: openssh-3.1p1-buffer.patch
Patch4: openssh_buffer.c_alloc.patch
Patch5: openssh-3.1p1-realloc.patch
PreReq: openssl >= 0.9.5a, zlib >= 1.1.4
Requires: openssl >= 0.9.5a
BuildPreReq: perl
BuildPreReq: openssl-devel
BuildPreReq: tcp_wrappers
BuildRoot: /var/tmp/%{name}-%{version}-root
URL: http://www.openssh.com/

%package clients
Summary: OpenSSH Secure Shell protocol clients
Requires: openssh
Group: Network/Clients
Obsoletes: ssh-clients

%package server
Summary: OpenSSH Secure Shell protocol server (sshd)
Group: Network/Services
Obsoletes: ssh-server
PreReq: openssh chkconfig >= 0.9 tsl-utils fileutils sed

%description
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package includes the core files necessary for both the OpenSSH
client and server.  To make this package useful, you should also
install openssh-clients, openssh-server, or both.

%description clients
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package includes the clients necessary to make encrypted connections
to SSH servers.

%description server
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package contains the secure shell daemon. The sshd is the server 
part of the secure shell protocol and allows ssh clients to connect to 
your host.

%prep

%setup -q -n %{name}-%{oversion}
%patch1 -p0
%patch2 -p0
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build

CFLAGS="$RPM_OPT_FLAGS" \
	./configure --prefix=/usr \
	--sysconfdir=/etc/ssh \
	--mandir=%{_mandir}\
        --with-tcp-wrappers \
        --with-ipv4-default \
	--mandir=%{_mandir} \
        --infodir=/usr/share/info \
	--with-pam \
	--with-lastlog=/var/log/lastlog

make
# Fix chkconfig part.
perl -pi -e "s/^# chkconfig:.*$/# chkconfig: - 55 45/" contrib/redhat/sshd.init

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT/

install -d $RPM_BUILD_ROOT/etc/pam.d/
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -d $RPM_BUILD_ROOT/usr/libexec/ssh
install -m600 $RPM_SOURCE_DIR/sshd_config  $RPM_BUILD_ROOT/etc/ssh
install -m644 contrib/redhat/sshd.pam $RPM_BUILD_ROOT/etc/pam.d/sshd
install -m755 contrib/redhat/sshd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sshd

%clean
rm -rf $RPM_BUILD_ROOT

%post server
if [ ! -f /etc/ssh/ssh_host_key -o ! -s /etc/ssh/ssh_host_key ]; then
	/usr/bin/ssh-keygen -t rsa1 -b 1024 -f /etc/ssh/ssh_host_key -N '' >&2
fi
if [ ! -f /etc/ssh/ssh_host_dsa_key -o ! -s /etc/ssh/ssh_host_dsa_key ]; then
	/usr/bin/ssh-keygen -t dsa -f /etc/ssh/ssh_host_dsa_key -N '' >&2
fi
if [ ! -f /etc/ssh/ssh_host_rsa_key -o ! -s /etc/ssh/ssh_host_rsa_key ]; then
	/usr/bin/ssh-keygen -t rsa -f /etc/ssh/ssh_host_rsa_key -N '' >&2
fi
# This one moved between 2.9.0p2 and 2.9.9p2
if [ -f /etc/ssh/primes -a ! -f /etc/ssh/moduli ]; then
	mv /etc/ssh/primes /etc/ssh/moduli
fi
# CheckMail option no longer present.
if [ -f /etc/ssh/sshd_config ]; then
	sed -e '/CheckMail/d' /etc/ssh/sshd_config > /etc/ssh/sshd_config.%{oversion}
	chmod --reference /etc/ssh/sshd_config /etc/ssh/sshd_config.%{oversion}
	mv /etc/ssh/sshd_config.%{oversion} /etc/ssh/sshd_config
fi
chkconfig --add sshd
/sbin/restart_maybe sshd

%preun server
if [ "$1" = 0 ]
then
	/etc/rc.d/init.d/sshd stop >&2
	/sbin/chkconfig --del sshd
fi

%files
%defattr(-,root,root)
%doc ChangeLog OVERVIEW README* INSTALL CREDITS LICENCE TODO RFC.nroff
%attr(0755,root,root) /usr/bin/scp
%attr(0755,root,root) /usr/bin/ssh-keygen
%attr(0755,root,root) /usr/bin/ssh-keyscan
%attr(0644,root,root) %{_mandir}/man1/scp.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-keygen.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-keyscan.1*
%attr(0755,root,root) %dir /etc/ssh
%attr(0755,root,root) %dir /usr/libexec/ssh

%files clients
%defattr(-,root,root)
%attr(0755,root,root) /usr/bin/sftp
%attr(4755,root,root) /usr/bin/ssh
%attr(0755,root,root) /usr/bin/ssh-add
%attr(0755,root,root) /usr/bin/ssh-agent
%attr(0644,root,root) %{_mandir}/man1/sftp.1*
%attr(0644,root,root) %{_mandir}/man1/ssh.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-agent.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-add.1*
%attr(0644,root,root) %config(noreplace) /etc/ssh/ssh_config
%attr(-,root,root) /usr/bin/slogin
%attr(-,root,root) %{_mandir}/man1/slogin.1*

%files server
%defattr(-,root,root)
%attr(0755,root,root) /usr/sbin/sshd
%attr(0755,root,root) /usr/libexec/sftp-server
%attr(0644,root,root) %{_mandir}/man8/sshd.8*
%attr(0644,root,root) %{_mandir}/man8/sftp-server.8*
%attr(0644,root,root) %config(noreplace) /etc/ssh/sshd_config
%attr(0600,root,root) %config(noreplace) /etc/ssh/moduli
%attr(0644,root,root) %config(noreplace) /etc/pam.d/sshd
%attr(0755,root,root) %config /etc/rc.d/init.d/sshd


%changelog
* Tue Sep 23 2003 Erlend Midttun <erlendbm@trustix.com>
- Say after me: Even more buffer allocation issues.  Partly fixed by
  the OpenSSH team and partly by Solar Designer.

* Wed Sep 17 2003 Erlend Midttun <erlendbm@trustix.com>
- Even more buffer allocation issues.

* Tue Sep 16 2003 Erlend Midttun <erlendbm@trustix.com>
- Fix buffer allocation error in buffer.c

* Fri Apr 26 2002 Christian H. Toldnes <christht@trustix.com>
- Patched to fix security issue if rebuilt with kerberos support.

* Fri Mar 15 2002 Christian H. Toldnes <christht@trustix.com>
- Fixed broken ssh-keygen in %post
- Added security Prereq on zlib >= 1.1.4

* Thu Mar  7 2002 Christian H. Toldnes <christht@trustix.com>
- New upstream version. Now 3.1

* Thu Jan  3 2002 Erlend Midttun <erlendbm@trustix.com>
- Fixed chkconfig part of startup.

* Fri Dec 21 2001 Erlend Midttun <erlendbm@trustix.com>
- Fixed file conflictm, take II.

* Thu Dec 20 2001 Erlend Midttun <erlendbm@trustix.com>
- Fixed file conflict.

* Wed Dec 19 2001 Erlend Midttun <erlendbm@trustix.com>
- Updated to 3.0.2p1 to fix uselogin security hole.

* Thu Oct  4 2001 Erlend Midttun <erlendbm@trustix.com>
- New upstream version.  Fixes a weakness in the key file option handling.

* Tue Jul  3 2001 Oystein Viggen <oysteivi@trustix.com>
- define _noVersionedDependencies

* Mon Jun 18 2001 Oystein Viggen <oysteivi@trustix.com>
- New upstream version 2.9p2
- Fix bug in default config file

* Mon Jun 11 2001 Erlend Midttun <erlendbm@trustix.com>
- New upstream version.

* Tue Mar 27 2001 Alexander Reelsen <ar@trustix.com>
- Upgraded to 2.5.2p2
- Fixed DSA protocol 2 problems

* Mon Feb 19 2001 Oystein Viggen <oysteivi@trustix.com>
- Get 2.5.1p1, adding an sftp client.

* Wed Nov 29 2000 Erlend Midttun <erlendbm@trustix.com>
- Fixed typo in group setting.  Thanks to Janke Ronnblom,
  <jan-ake.ronnblom@skeria.skelleftea.se> for pointing this out.

* Wed Nov 15 2000 Erlend Midttun <erlendbm@trustix.com>
- Updated to 2.3.0p1 to fix some security issues.

* Thu Sep 14 2000 Per Ivar Paulsen <perp@trustix.com>
- Picked up 2.2.0p1

* Tue Jun 13 2000 Oystein Viggen <oysteivi@trustix.com>
- Upgraded to version 2.1.1p1

* Wed Jun 07 2000 Erlend Midttun <erlendbm@trustix.com>
- Added loginprogram hack.
- Added hack to fix utmp/wtmp problems

* Tue Jun 06 2000 Erlend Midttun <erlendbm@trustix.com>
- Upgraded to version 2.1.0p3

* Thu May 18 2000 Erlend Midttun <erlendbm@trustix.com>
- Removed X and gnome packages

* Wed Mar 15 2000 Damien Miller <djm@ibs.com.au>
- Updated for new location
- Updated for new gnome-ssh-askpass build

* Sun Dec 26 1999 Damien Miller <djm@mindrot.org>
- Added Jim Knoble's <jmknoble@pobox.com> askpass

* Mon Nov 15 1999 Damien Miller <djm@mindrot.org>
- Split subpackages further based on patch from jim knoble <jmknoble@pobox.com>

* Sat Nov 13 1999 Damien Miller <djm@mindrot.org>
- Added 'Obsoletes' directives

* Tue Nov 09 1999 Damien Miller <djm@ibs.com.au>
- Use make install
- Subpackages

* Mon Nov 08 1999 Damien Miller <djm@ibs.com.au>
- Added links for slogin
- Fixed perms on manpages

* Sat Oct 30 1999 Damien Miller <djm@ibs.com.au>
- Renamed init script

* Fri Oct 29 1999 Damien Miller <djm@ibs.com.au>
- Back to old binary names

* Thu Oct 28 1999 Damien Miller <djm@ibs.com.au>
- Use autoconf
- New binary names

* Wed Oct 27 1999 Damien Miller <djm@ibs.com.au>
- Initial RPMification, based on Jan "Yenya" Kasprzak's <kas@fi.muni.cz> spec.
